/*
  generic audiodevice
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <devices/audioDevice.h>



AudioDevice::AudioDevice(char* device) {
  audioInfo=new YafAudioInfo();
}


AudioDevice::~AudioDevice() {
  delete audioInfo;
}


char* AudioDevice::getNodeName() {
  return "AudioDevice";
}


YafAudioInfo* AudioDevice:: getAudioInfo() {
  return audioInfo;
}


void AudioDevice::setAudioInfo(YafAudioInfo* info) {
  info->copyTo(audioInfo);
}



void AudioDevice::writeIn(NodeDevice* source,DeviceConfig* buf) {
  AudioBuffer* buffer=buf->getAudioBuffer();
  MemChunk* memChunk=buffer->getMemChunk();

  if (needInit(buf)) {
    setDeviceConfig(buf);
  }
  rawWrite(memChunk->getPtr(),memChunk->getLen());
}
  

int AudioDevice::needInit(DeviceConfig* buf) {
  /*
  if (buf->getBufferUnderrun()) {
    cout << "getBufferUnderrun in AudioDevice -> reinir needed!"<<endl;
    return true;
  }
  */
  if (audioInfo->equals(buf->getAudioInfo())) {
    return (false);
  }
  return true; 
}



void AudioDevice::setDeviceConfig(DeviceConfig* buf) {
}


int AudioDevice::rawWrite(char* buf,int len) {
  return len;
}


int AudioDevice::getPreferredBufferSize() {
  int back=_DEFAULT_AUDIO_BUFFERSIZE;
  return back;
}





